# $Id: main.s,v 1.3 1994-11-09 21:42:11+0900 Mipro Exp $
# main.s : main module.

#-
# Copyright (C) 1994 GENEration SYStem Software labo Distribution.
# last change : $Date: 1994-11-09 21:42:11+0900 $ : $Author: Mipro $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with This program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

	.include	doscall.mac
	.include	standard.mac

	.xdef	main
	.xref	strip_path
	.xref	strip_suffix

	.text
	.even
rcs_header:
		.dc.b	'$Id: main.s,v 1.3 1994-11-09 21:42:11+0900 Mipro Exp $',CR,LF,0
		.even
main:
		move.l	d0,d1
		beq	usage
		cmp.l	#3,d1
		bge	usage

		move.l	a2,a0
		bsr	strip_path

		cmp.l	#1,d1
		beq	done_program

		move.l	a2,a4
@@:
		tst.b	(a4)+
		bne	@b
@@:
		tst.b	(a4)+
		bne	@b
*		subq.l	#2,a4
		subq.w	#2,a4

		move.l	a0,a3
@@:
		tst.b	(a3)+
		bne	@b
*		subq.l	#2,a3
		subq.w	#2,a3

		bsr	strip_suffix

done_program:
		move.w	#STDOUT,-(sp)
		move.l	a0,-(sp)
		DOS	__FPUTS
		lea.l	newline(pc),a0
		move.l	a0,(sp)
		DOS	__FPUTS
*		addq.l	#6,sp
		addq.w	#6,sp
		moveq.l	#0,d0
		rts
usage:
		move.w	#STDERR,-(sp)
		pea.l	usage_header(pc)
		DOS	__FPUTS
*		addq.l	#4,sp
		addq.w	#4,sp
		move.l	a3,-(sp)
		DOS	__FPUTS
*		addq.l	#4,sp
		addq.w	#4,sp
		pea.l	usage_mes(pc)
		DOS	__FPUTS
*		addq.l	#6,sp
		addq.w	#6,sp
		moveq.l	#1,d0
		rts


	.data
	.even
newline:
	.dc.b	CR,LF,0
usage_header:
	.dc.b	'usage: ',0
usage_mes:
	.dc.b	' filename [suffix]',CR,LF,0

	.end
