# $Id: strip.s,v 1.5 1995-01-22 06:04:56+0900 Mipro Exp $
# strip.s : strip module.

#-
# Copyright (C) 1994 GENEration SYStem Software labo Distribution.
# last change : $Date: 1995-01-22 06:04:56+0900 $ : $Author: Mipro $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with This program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

	.include	doscall.mac
	.include	standard.mac

	.xdef	strip_path
	.xdef	strip_suffix
	.xref	_TwentyOneOptions

	.text
	.even
rcs_header:
		.dc.b	CR,LF,'$Id: strip.s,v 1.5 1995-01-22 06:04:56+0900 Mipro Exp $',CR,LF,0
		.even

#
# strip_suffix
#
1:
*		subq.l	#1,a3
strip_suffix:
		bsr	_TwentyOneOptions
		tst.l	d0
		beq	@f
		cmp.l	#-1,d0
		beq	@f
		btst.l	#30,d0
		beq	@f
		bra.s	5f
1:
		subq.w	#1,a3
@@:
		move.b	(a4),d0
		cmp.b	(a3),d0
		bne	3f
2:
*		subq.l	#1,a4
		subq.w	#1,a4
		tst.b	(a4)
		bne	1b
		clr.b	(a3)
3:
		move.b	d0,d2
		add.b	#$20,d2
		cmp.b	(a3),d2
		beq	2b

		move.b	d0,d2
		sub.b	#$20,d2
		cmp.b	(a3),d2
		beq	2b
		rts

4:
		subq.l	#1,a3
5
		move.b	(a4),d0
		cmp.b	(a3),d0
		bne	6f
		subq.l	#1,a4
		tst.b	(a4)
		bne	4b
		clr.b	(a3)
6:
		rts

#
# strip path
#
# in:a0
#	pathname adress
# out:a0
#	filename adress
#
strip_path:
		move.l	a1,-(sp)
		move.l	a0,a1
		bra.s	2f
1:
*		addq.l	#1,a1
		addq.w	#1,a1
		move.l	a1,a0
2:
		tst.b	(a1)
		beq	3f
		cmp.b	#':',(a1)
		beq	1b
		cmp.b	#'\',(a1)
		beq	1b
		cmp.b	#'/',(a1)
		beq	1b
*		addq.l	#1,a1
		addq.w	#1,a1
		bra	2b
3:
		move.l	(sp)+,a1
		rts

		.end
